(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.multimania.com/haypo/ $$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
               Programmme de test du clavier au format ASCII                
Ĵ
  Fichiers ncessaires                                                    
                                                    
                                                                            
 -> 'ClavAsci.Pcx'  : Image de fond                                         
*)

{$M 4096,0,16000}

uses Clavier,EcranVga,FaitPaus,PalVideo,Pcx;

const
  CoulFond = 255;
  MasqueB : array[0..7] of byte = (1,2,4,8,16,32,64,128);
  Rouge : RVB = (R:63; V: 0; B: 0);
  Vert  : RVB = (R: 0; V:63; B: 0);
  TouchIndexPal : array[0..7] of byte = (
    { bit 0 : Majuscule D.   } 252,
    { bit 1 : Majuscule G.   } 251,
    { bit 2 : Ctrl           } 250,
    { bit 3 : Alt            } 176,
    { bit 4 : Dfilement     } 170,
    { bit 5 : Pav numrique } 247,
    { bit 6 : Majuscule      } 246,
    { bit 7 : Insert         } 244);

var
  Clav: record
    CodeAscii,SauveAscii : char;
    SauveCoul : RVB;
    Etat: array [0..7] of boolean;
  end;

  EtatClavier : byte absolute $0040: $0017;

  blanc,i : byte;
  txt : string;

procedure LitToucheSpeciale; begin
  { Passage des masques }
  with Clav do for i := 0 to 7 do
    Etat[i] := EtatClavier and MasqueB[i] = MasqueB[i];
end;

begin
   ModeVga256; AffichePcx (0,0,'ClavAsci.pcx');

   blanc := CouleurBlanche;
   EcriTsp (235,50,'Code Ascii',blanc);
   EcriTsp (260,60,'???',blanc);

   with Clav do begin
     CodeAscii := _ENTREE;
     SauveAscii := CodeAscii;
     with SauveCoul do LitPal (ord(CodeAscii), R,V,B);
   end;

   ChangePal (CoulFond,32,32,63);

   repeat
     LitToucheSpeciale;

     { Change la palette des touches spciales }
     AttendEcran;
     with Clav do for i := 0 to 7 do if Etat[i] then
       with Vert  do ChangePal (TouchIndexPal[i], R,V,B)
     else
       with Rouge do ChangePal (TouchIndexPal[i], R,V,B);

     { Aucune touche presse -> On se tire }
     if TouchPresse then with Clav do begin
       SauveAscii := CodeAscii;
       CodeAscii := UpCase(LitTouche);

       with SauveCoul do ChangePal (ord(SauveAscii), R,V,B);
       with SauveCoul do LitPal    (ord(CodeAscii),  R,V,B);
       with Vert      do ChangePal (ord(CodeAscii),  R,V,B);

       str (ord(CodeAscii):3,txt); EcriVga (260,60,txt,CouleurBlanche,CoulFond);
     end;
  until (Clav.CodeAscii=_ECHAPE);

  Pause(300); ModeTxt;
end.